#define ITEM_MODE_SWAP		0
#define ITEM_MODE_TAKE		1
#define ITEM_MODE_NONE		2
//#define ITEM_MODE_INFO		3

aref g_refItems;

int nCurScroll1;
int nCurScroll2;

string oldNodeName="";
int oldItemMode = -1;

bool g_bIBoxUsed;

string oldCurScrollName = "ONE_ITEMSLIST";

string boxName
string boxType;
string curLoc;
bool isItemsBox = false;

int idLngFile;

bool bEnableDown = false;
ref lootedChar;
bool noConfirm = false; // added by MAXIMUS [confirmation dialog will be disabled, if character hasn't any items]

void InitInterface_RS(string iniName,ref itemsRef,string faceID)
{
	ref pch = GetMainCharacter();

    // JRH fix oct 06: remove the ghost gp -->
	if(ENABLE_AMMOMOD == 1)
	{
		int gp = GetCharacterItem(pch, "gunpowder");
		if(gp == 0)
		{
			TakenItems(pch, "gunpowder", 1); TakenItems(pch, "gunpowder", -1);
		}
	}
    // <-- JRH

	lootedChar = itemsRef;
	pch.skiprecalcskill = true;
	DeleteAttribute(&pch,"skill.Leadership.mod"); // NK/GZ items mod
	DeleteAttribute(&pch,"skill.Fencing.mod"); // NK/GZ items mod
	DeleteAttribute(&pch,"skill.Sailing.mod"); // NK/GZ items mod
	DeleteAttribute(&pch,"skill.Accuracy.mod"); // NK/GZ items mod
	DeleteAttribute(&pch,"skill.Cannons.mod"); // NK/GZ items mod
	DeleteAttribute(&pch,"skill.Grappling.mod"); // NK/GZ items mod
	DeleteAttribute(&pch,"skill.Repair.mod"); // NK/GZ items mod
	DeleteAttribute(&pch,"skill.Defence.mod"); // NK/GZ items mod
	DeleteAttribute(&pch,"skill.Commerce.mod"); // NK/GZ items mod
	DeleteAttribute(&pch,"skill.Sneak.mod"); // NK/GZ items mod

// changed by MAXIMUS -->
   //JRH -->
	string weaponID = GetCharacterEquipByGroup(pch,GUN_ITEM_TYPE);
	aref weapon;
	Items_FindItem(weaponID, &weapon);

	int s; //shots
	int ShCl = makeint(GetCharacterShipClass(GetMainCharacter()));
    //JRH <--

	// TIH lets just set this here, so its not pasted every other line below 7-7-06
	// this is never changed to true anyway, so I really don't understand the need for it
	isGunpowder = false;

	// TIH --> total house cleaning 7-7-06
	if(faceID=="")
	{
		boxName = pch.boxname;
		boxType = strcut(boxName, 0, strlen(boxName)-3);
		curLoc = Locations[FindLocation(pch.location)].filespath.models;
		int powderCount;
		string whichInterface = "";

		// TIH --> treasure quest update Aug31'06
		// if they finally open the box, the location is removed
		if (CheckAttribute(pch,"trlocation") && CheckAttribute(pch,"trlocator") && CheckAttribute(pch,"trlocatorfound"))
		{
			if (pch.location == pch.trlocation && pch.trlocator == pch.trlocatorfound)
			{
//				CloseQuestHeader(("treasure_" + pch.trquestnum)); // close the entry
				CloseQuestHeader("treasure"); // close the entry
				pch.trquestnum = "";		// no more!
				pch.trlocatorfound = "";	// deletes the treasureinfo...
				pch.trlocation = "";		// so that you can find it only once...
				pch.trlocator = "";			// dont close the box without looting!
			}
		}
		// TIH <--
		//changed by MAXIMUS: box-labels weren't right -->
			if(boxName=="WeaponsLocker") { whichInterface = "Weaponslocker"; }
			else
			{
				if(boxType == "gunpowder")
				{
					if(boxName == "gunpowder_1")
					{
						if(LAi_IsBoardingProcess())
						{
							if (HasSubStr(pch.location, "BOARDING_")) // KK
								whichInterface = "GunpowderStorageEnemy";
							else
								whichInterface = "GunpowderBarrelEnemy";
						}
						else
						{
							if(HasSubStr(curLoc,"locations\decks\udec")) { whichInterface = "GunpowderBarrel"; }
							else { whichInterface = "GunpowderStorage"; }
						}
					}
					else
					{
						if(LAi_IsBoardingProcess()) { whichInterface = "GunpowderBarrelEnemy"; }
						else { whichInterface = "GunpowderBarrel"; }
					}
				}
				else
				{
					if(HasSubStr(boxName, "box") && HasSubStr(curLoc, "locations\decks")) { whichInterface = "SeaBox"; }
					else { whichInterface = "ItemsBox"; }
				}
			}
		//changed by MAXIMUS: box-labels weren't right -->

		// do specific actions based on the whichInterface HERE
		switch (whichInterface)
		{
			case "Weaponslocker":
				GameInterface.title = "titleWeaponslocker";
				PlaySound("AMBIENT\JAIL\door_003.wav");// was door_002 which is corrupted in a way
				isGunpowder = false;
				isItemsBox = true;
				break;

			case "SeaBox":
				GameInterface.title = "titleSeaBox";
				PlaySound("AMBIENT\JAIL\door_001.wav");
				isGunpowder = false;
				isItemsBox = true;
				break;

			case "ItemsBox":
				GameInterface.title = "titleItemsBox";
				PlaySound("AMBIENT\JAIL\door_003.wav");// was door_004 which is corrupted in a way
				isGunpowder = false;
				isItemsBox = true;
				break;

			case "GunpowderStorage":
				GameInterface.title = "titleGunpowderStorage";
				isGunpowder = true;
				isItemsBox = false;
				PlaySound("AMBIENT\JAIL\door_003.wav");// was door_002 which is corrupted in a way
				if(ENABLE_AMMOMOD==1) {// TIH --> mod toggle 7-7-06


				// JRH fix oct 06: old code but functional -->
					bool bAmmoTaken = false;
					int pb = GetCharacterItem(pch, "pistolbullets");
					int pg = GetCharacterItem(pch, "pistolgrapes");
					int mb = GetCharacterItem(pch, "musketbullets");
					int p;

					locations[FindLocation(pch.location)].(boxName).items.gunpowder = 300*(8 - ShCl) + rand(100);
					locations[FindLocation(pch.location)].(boxName).items.pistolbullets = 300*(8 - ShCl) + rand(100);
					locations[FindLocation(pch.location)].(boxName).items.pistolgrapes = 75*(8 - ShCl) + rand(75);
					locations[FindLocation(pch.location)].(boxName).items.musketbullets = 15*(8 - ShCl) + rand(15);

					if(CheckAttribute(weapon, "shottype") )
					{
						if(weapon.shottype == "pg2" || weapon.shottype == "pg" || weapon.shottype == "mb" || weapon.shottype == "pb")
						{
							if(CheckAttribute(pch,"equip."+FLASK_ITEM_TYPE) ) { p = 12; }
							else { p = 6; }

							if(CheckAttribute(pch,"equip."+POUCH_ITEM_TYPE) ) { s = 12;}
							else { s = 6; }

							if(gp < p) bAmmoTaken = true;

							if(weapon.shottype == "pg2" || weapon.shottype == "pg")
							{
								if(pg < s) bAmmoTaken = true;
							}
							if(weapon.shottype == "mb")
							{
								if(mb < s/2) bAmmoTaken = true;
							}
							if(weapon.shottype == "pb")
							{
								if(pb < s) bAmmoTaken = true;
							}

							TakeNItems(pch,"gunpowder", -100); TakeNItems(pch,"pistolbullets", -100);
							TakeNItems(pch,"pistolgrapes", -100); TakeNItems(pch,"musketbullets", -100);

							if(weapon.shottype == "pg2" || weapon.shottype == "pg") TakeNItems(pch,"pistolgrapes", s);
							if(weapon.shottype == "mb") TakeNItems(pch,"musketbullets", s/2);
							if(weapon.shottype == "pb") TakeNItems(pch,"pistolbullets", s);
							TakeNItems(pch,"gunpowder", p);

							if(bAmmoTaken)
							{
								Log_SetStringToLog("I have taken Pistol Ammunition!");
								PlaySound("INTERFACE\important_item.wav");
							}
						}
					}
				//<-- old code JRH
				}// TIH <-- mod toggle
				break;

			case "GunpowderBarrel":
				GameInterface.title = "titleGunpowderBarrel";
				PlaySound("AMBIENT\JAIL\door_003.wav");
				if (CANNONPOWDER_MOD) {// TIH --> mod toggle 7-7-06
					//JRH in here
					powderCount = GetCargoGoods(pch, GOOD_GUNPOWDER);
					locations[FindLocation(pch.location)].(boxName).open = true;
					locations[FindLocation(pch.location)].(boxName).items.gunpowder = powderCount;
				}// TIH <-- mod toggle
				isGunpowder = true;
				isItemsBox = false;
				break;

			case "GunpowderStorageEnemy":
				GameInterface.title = "titleGunpowderStorage";
				PlaySound("AMBIENT\JAIL\door_003.wav");// was door_002 which is corrupted in a way
				if (CANNONPOWDER_MOD) {// TIH --> mod toggle 7-7-06
					if(bAbordageStarted && !bCabinStarted && !bDeckStarted && !bCrewStarted)
					{
						powderCount = GetCargoGoods(boarding_enemy, GOOD_GUNPOWDER);
						locations[FindLocation(pch.location)].(boxName).open = true;
						locations[FindLocation(pch.location)].(boxName).items.gunpowder = powderCount;
					}
				}// TIH <-- mod toggle
				isGunpowder = true;
				isItemsBox = false;
				break;

			case "GunpowderBarrelEnemy":
				GameInterface.title = "titleGunpowderBarrel";
				PlaySound("AMBIENT\JAIL\door_003.wav");
				if (CANNONPOWDER_MOD) {// TIH --> mod toggle 7-7-06
					if(bAbordageStarted && !bCabinStarted && !bDeckStarted && !bCrewStarted)
					{
						powderCount = GetCargoGoods(boarding_enemy, GOOD_GUNPOWDER);
						locations[FindLocation(pch.location)].(boxName).open = true;
						locations[FindLocation(pch.location)].(boxName).items.gunpowder = powderCount;
					}
				}// TIH <-- mod toggle
				isGunpowder = true;
				isItemsBox = false;
				break;

		}// end switch whichInterface

	}
	else
	{
		GameInterface.title = ""; isGunpowder = false;	// LDH set this to prevent missing attribute error later - 06Mar09
		// changed by MAXIMUS -->
		if(bDeadExchange==true) { GameInterface.title = "titleExchangeWithDead"; isGunpowder = false; }
		if(bEnemyExchange==true) { GameInterface.title = "titleExchangeWithEnemy"; isGunpowder = false; }
		if(bStealExchange==true) { GameInterface.title = "titleExchangeByStealing"; isGunpowder = false; }

		// LDH this needs to go through all the passengers, not just the active officers - 06Mar09
		// it works the way it is because of a test later in the code
		for(int i = 1; i < 4; i++)
		{
		    ref Char = GetCharacter(GetOfficersIndex(GetMainCharacter(), i));
			if(CheckAttribute(Char,"faceID"))
			{
			  if(faceID==Char.faceID) GameInterface.title = "titleExchangeItems";
			  isGunpowder = false;
			}
		}

		// changed by MAXIMUS <--

		// Viper - Kindly ask that officer to unequip the stuff
		RemoveCharacterEquip(itemsRef, GUN_ITEM_TYPE);
		RemoveCharacterEquip(itemsRef, BLADE_ITEM_TYPE);
		RemoveCharacterEquip(itemsRef, ARMOR_ITEM_TYPE); // NK
		RemoveCharacterEquip(itemsRef, FLASK_ITEM_TYPE); //JRH
		RemoveCharacterEquip(itemsRef, POUCH_ITEM_TYPE); //JRH
		itemsRef.skiprecalcskill = true;
		//remove all skill modifiers
		DeleteAttribute(&itemsRef,"skill.Leadership.mod"); // NK/GZ items mod
		DeleteAttribute(&itemsRef,"skill.Fencing.mod"); // NK/GZ items mod
		DeleteAttribute(&itemsRef,"skill.Sailing.mod"); // NK/GZ items mod
		DeleteAttribute(&itemsRef,"skill.Accuracy.mod"); // NK/GZ items mod
		DeleteAttribute(&itemsRef,"skill.Cannons.mod"); // NK/GZ items mod
		DeleteAttribute(&itemsRef,"skill.Grappling.mod"); // NK/GZ items mod
		DeleteAttribute(&itemsRef,"skill.Repair.mod"); // NK/GZ items mod
		DeleteAttribute(&itemsRef,"skill.Defence.mod"); // NK/GZ items mod
		DeleteAttribute(&itemsRef,"skill.Commerce.mod"); // NK/GZ items mod
		DeleteAttribute(&itemsRef,"skill.Sneak.mod"); // NK/GZ items mod
	}
	// TIH <-- total house cleaning
	g_refItems = itemsRef;

	bool bFromCharacterScreen = CheckAttribute(pch, "ExchangeItemsFromCharacterScreen"); // KK
	if (!bFromCharacterScreen) { // KK
		locCameraSleep(true);
		SetTimeScale(0.0);

		Log_SetActiveAction("Nothing");
		BLIVisible(false);
		SendMessage(&IActions,"ll",LI_SET_VISIBLE,false);

		LayerFreeze("realize",bSeaActive && !ownDeckStarted() && !LAi_IsBoardingProcess());
		LayerFreeze("execute",true);
		bool bShow = ownDeckStarted();
		if(!bShow) bShow = LAi_IsBoardingProcess();
		LayerFreeze("sea_realize",!bSeaActive && bShow);
		LayerFreeze("sea_execute",true);
	}

	FillScroll();
// KK -->
	InitToolTip();
	SetImageGroups();
	SetToolTip();

	GameInterface.MyPic.current = 0;
	GameInterface.MyPic.ImagesGroup.t0 = "EMPTYFACE";
	GameInterface.MyPic.pic1.str1 = "";
	GameInterface.MyPic.pic1.img1 = "emptyface";
	if (bNewInterface) GameInterface.MyPic.pic1.img1 = "emptyface_new";
	GameInterface.MyPic.pic1.tex1 = 0;
	GameInterface.MyPic.ListSize = 1;
	GameInterface.MyPic.NotUsed = 0;

	GameInterface.FACEPICT.current = 0;
	GameInterface.FACEPICT.ImagesGroup.t0 = "EMPTYFACE";
	GameInterface.FACEPICT.ImagesGroup.t1 = "GOODS";
	GameInterface.FACEPICT.ImagesGroup.t2 = "RELATIONS";
	GameInterface.FACEPICT.ImagesGroup.t3 = "BOX_IMAGE";
	GameInterface.FACEPICT.pic1.str1 = "";
	GameInterface.FACEPICT.pic1.img1 = "emptyface";
	if (bNewInterface) GameInterface.FACEPICT.pic1.img1 = "emptyface_new";
	GameInterface.FACEPICT.pic1.tex1 = 0;
	GameInterface.FACEPICT.ListSize = 1;
	GameInterface.FACEPICT.NotUsed = 0;
// <-- KK

	SendMessage(&GameInterface,"ls",MSG_INTERFACE_INIT,iniName);
	CreateExitString();//MAXIMUS: standard exit-string for exit-button
// KK -->
	if (!bFromCharacterScreen) {
		SetNodeUsing("VIDEOBASE",false);
		SetNodeUsing("BACKSLIDE",false);
		SetNodeUsing("SCROLLRECTANGLE",false);
		SetNodeUsing("DOWNSCROLLRECT",false);
		SetNodeUsing("DOWNRECTSMOOTH",false);
		SetNodeUsing("TITLE",false);
		CreateString(true, "ScreenTitle", XI_ConvertString(GameInterface.title), FONT_TITLE, COLOR_NORMAL, 320, 6, SCRIPT_ALIGN_CENTER, 1.0);
		SetNodeUsing("CENTERRECTANGLE",false);
		SetNodeUsing("CENTERBOUND",false);
		if(bAnimation) SetNodeUsing("BACKGROUND",false); // PB: Dynamic Interfaces
		SetNodeUsing("INFO",false);
	}

	//CreateImage("MyPic",GetFaceGroupName(GetMainCharacterIndex()),GetFacePictureName(GetMainCharacterIndex()),5,39,133,167);

	GameInterface.MyPic.pic1.str2 = "#" + GetMySimpleName(pch);
	GameInterface.MyPic.pic1.img1 = GetFacePictureName(GetMainCharacterIndex());
	AddFaceGroup("MyPic.ImagesGroup", GetFaceGroupName(GetMainCharacterIndex()));
	GameInterface.MyPic.pic1.tex1 = FindFaceGroupNum("MyPic.ImagesGroup", GetFaceGroupName(GetMainCharacterIndex()));
	SendMessage(&GameInterface, "ls", MSG_INTERFACE_REFRESH_SCROLL, "MyPic");

	GameInterface.pictures.OtherPic.tex = "";
	GameInterface.pictures.OtherPic.pic = "";
	if(faceID == "") {
		g_bIBoxUsed = true;
		if (boxType == "gunpowder") {
			//CreateImage("OtherPic","GOODS","Gunpowder",-5,292,143,450);// TIH no need for mod toggle on this 7-7-06
			GameInterface.FACEPICT.pic1.str2 = "Gunpowder";
			GameInterface.FACEPICT.pic1.img1 = "Gunpowder";
			GameInterface.FACEPICT.pic1.tex1 = 1;
		} else {
			curLoc = Locations[FindLocation(pch.location)].filespath.models;
			if (boxName == "WeaponsLocker") {
				//CreateImage("OtherPic","RELATIONS","Enemy",-5,292,143,450);
				GameInterface.FACEPICT.pic1.str2 = "Weaponslocker";
				GameInterface.FACEPICT.pic1.img1 = "Enemy";
				GameInterface.FACEPICT.pic1.tex1 = 2;
			} else {
				//CreateImage("OtherPic","BOX_IMAGE","BoxImage",5,302,133,430);
				GameInterface.FACEPICT.pic1.str2 = "ItemsBox";
				if (ownDeckStarted()) GameInterface.FACEPICT.pic1.str2 = "SeaBox";
				if (LAi_IsBoardingProcess() && !IsFort && !IsTown) GameInterface.FACEPICT.pic1.str2 = "SeaBox";
				GameInterface.FACEPICT.pic1.img1 = "BoxImage";
				GameInterface.FACEPICT.pic1.tex1 = 3;
			}
		}
	} else {
		g_bIBoxUsed = false;
// changed by MAXIMUS -->
		if (CheckAttribute(GameInterface, "title") && GameInterface.title == "titleExchangeWithDead") {	// LDH fix for missing attrib
		    SetNewPicture("EN_PIC", "interfaces\portraits\128\face_skull.tga");
			//SetNewPicture("FACEPICT", "interfaces\portraits\128\face_skull.tga");
			GameInterface.FACEPICT.pic1.str2 = "#" + XI_ConvertString("BodyOf") + GetMySimpleName(lootedChar);
			GameInterface.FACEPICT.pic1.img1 = "";
			GameInterface.FACEPICT.pic1.tex1 = "";
			GameInterface.FACEPICT.BadPicture1 = "interfaces\portraits\128\face_skull.tga";
		} else {
		    SetNewPicture("EN_PIC", "interfaces\portraits\128\face_" + faceID + ".tga");
			//SetNewPicture("FACEPICT", "interfaces\portraits\128\face_" + faceID + ".tga");
			GameInterface.FACEPICT.pic1.str2 = "#" + GetMySimpleName(lootedChar);
			GameInterface.FACEPICT.pic1.img1 = GetFacePictureName(sti(lootedChar.index));
			AddFaceGroup("FACEPICT.ImagesGroup", GetFaceGroupName(sti(lootedChar.index)));
			GameInterface.FACEPICT.pic1.tex1 = FindFaceGroupNum("FACEPICT.ImagesGroup", GetFaceGroupName(sti(lootedChar.index)));
		}
// changed by MAXIMUS <--
	}
	SendMessage(&GameInterface, "ls", MSG_INTERFACE_REFRESH_SCROLL, "FACEPICT");
	SetNodeUsing("FACEPICT", true);
// <-- KK

	CreateString(TRUE,"itemname","",FONT_NORMAL,COLOR_NORMAL,320,475,SCRIPT_ALIGN_CENTER,0.8); // NK

// added by MAXIMUS-->
	SetSelectable("EXIT_BUTTON",true);
	SetNodeUsing("CONFIRM_RECTANGLE",false);
	SetNodeUsing("TEXTWINDOW",false);
	SetNodeUsing("CONFIRM_YES_BUTTON",false);
	SetNodeUsing("CONFIRM_NO_BUTTON",false);
	SetNodeUsing("REL_PIC",false);
	SetNodeUsing("EN_PIC",false);
// added by MAXIMUS <--

	SetEventHandler("InterfaceBreak","ProcessCancelExit",0);
	SetEventHandler("exitCancel","ProcessCancelExit",0);
	SetEventHandler("frame","FrameProcess",1);

	SetEventHandler("ievnt_command","ProcInterfaceCommand",0);
// added by MAXIMUS-->
	SetEventHandler("ExitPress","ProcessExit",0);
	SetEventHandler("ExitNo","ProcessExit_no",0);
	SetEventHandler("ExitYes","ProcessExit_yes",0);
// added by MAXIMUS <--

	SetItemMode(ITEM_MODE_SWAP);

	IGotoNewNode("TWO_ITEMSLIST");
	IGotoNewNode("ONE_ITEMSLIST");

	SetUpDownUsed();
	SetScrollsUsing();
}

// added by MAXIMUS -->
void ProcessExit()
{
	string faceID;
	SetNodeUsing("CONFIRM_RECTANGLE",true);
	SetNodeUsing("TEXTWINDOW",true);
	SetNodeUsing("CONFIRM_YES_BUTTON",true);
	SetNodeUsing("CONFIRM_NO_BUTTON",true);
	SetNodeUsing("REL_PIC",true);
	SetNodeUsing("EN_PIC",true);
	SetCurrentNode("CONFIRM_NO_BUTTON");
	SendMessage(&GameInterface,"lls", MSG_INTERFACE_LOCK_NODE, 1, "CONFIRM_NO_BUTTON");
	SendMessage(&GameInterface,"lls", MSG_INTERFACE_LOCK_NODE, 2, "CONFIRM_YES_BUTTON");

	SetFormatedText("TEXTWINDOW", TranslateString("","Exit from exchange confirm"));
}

void ProcessExit_no()
{
	SendMessage(&GameInterface,"ll", MSG_INTERFACE_LOCK_NODE, 0);

	SetNodeUsing("CONFIRM_RECTANGLE",false);
	SetNodeUsing("TEXTWINDOW",false);
	SetNodeUsing("CONFIRM_YES_BUTTON",false);
	SetNodeUsing("CONFIRM_NO_BUTTON",false);
	SetNodeUsing("REL_PIC",false);
	SetNodeUsing("EN_PIC",false);

	SetCurrentNode("INFO_BUTTON");
}

void ProcessExit_yes()
{
//	if(oldItemMode==ITEM_MODE_INFO) SetItemMode(ITEM_MODE_SWAP);
//	else IDoExit(RC_INTERFACE_ITEMSBOX_EXIT);
//	else
	IDoExit(RC_INTERFACE_DO_RESUME_GAME);
}
// added by MAXIMUS <--

void FrameProcess()
{
// KK -->
	if (!bRMouseDown)
		HideToolTip();
	else
		return;
// <-- KK

	IGotoNewNode(GetCurrentNode());

	if( nCurScroll1 != sti(GameInterface.one_itemslist.current) ||
		nCurScroll2 != sti(GameInterface.two_itemslist.current) )
	{
		nCurScroll1 = sti(GameInterface.one_itemslist.current);
		nCurScroll2 = sti(GameInterface.two_itemslist.current);
		if(oldItemMode!=ITEM_MODE_SWAP)	{SetItemMode(ITEM_MODE_SWAP);}
		SetUpDownUsed();
	}
}

void FillScroll()
{
	int i,j,q;
    string attributeName, name;
	aref curItem,arItem,rootItems;
	aref arImgGrp;
	ref mchref = GetMainCharacter();

	if(CheckAttribute(&GameInterface,"one_itemslist.current"))
		nCurScroll1 = sti(GameInterface.one_itemslist.current);
	else	nCurScroll1 = 0;
	if(CheckAttribute(&GameInterface,"two_itemslist.current"))
		nCurScroll2 = sti(GameInterface.two_itemslist.current);
	else	nCurScroll2 = 0;

	DeleteAttribute(&GameInterface,"one_itemslist");
	DeleteAttribute(&GameInterface,"two_itemslist");

	//============================================================================
	// PLAYER ITEMS
	//============================================================================
	GameInterface.one_itemslist.NotUsed = 5;
	GameInterface.one_itemslist.current = nCurScroll1;
	GameInterface.one_itemslist.ImagesGroup.t0 = "usedflag";// TIH
	GameInterface.one_itemslist.ImagesGroup.t1 = "ICONS";// TIH
	makearef(arImgGrp,GameInterface.one_itemslist.ImagesGroup);
	FillImagesGroupForItems(arImgGrp);

	i=0;
	// figure out the total gold the player has and add it to the first scroll item
	if( sti(mchref.Money)>0 )
	{
		GameInterface.one_itemslist.pic1.img1 = GetItemPictureName("Gold");
		GameInterface.one_itemslist.pic1.tex1 = GetItemPictureTexture("one_itemslist.ImagesGroup","Gold");
		GameInterface.one_itemslist.pic1.itemID = "Money";
		GameInterface.one_itemslist.pic1.str1 = "#"+sti(mchref.Money);		// LDH 15Oct06 fix for decimal point money
		if(bAnimation) GameInterface.one_itemslist.pic1.str2 = "Gold"; // KK: Dynamic Interfaces
		i++;
	}
	// loop through all items except maps of the player and add to scroller
	makearef(rootItems,mchref.Items);
	for(j=0; j<GetAttributesNum(rootItems); j++)
    {
		attributeName = "pic" + (i+1);
		curItem = GetAttributeN(rootItems,j);
		if (GetAttributeName(curItem) == "bladeX4") continue;// TIH simply never show fists in looting screens 7-7-06

		if( Items_FindItem(GetAttributeName(curItem),&arItem)>=0 )
		{
			if (CheckAttribute(arItem, "groupID") == true && arItem.groupID == MAP_ITEM_TYPE) continue; // KK
			GameInterface.one_itemslist.(attributeName).img1 = GetItemPictureName(arItem.id);
			GameInterface.one_itemslist.(attributeName).tex1 = GetItemPictureTexture("one_itemslist.ImagesGroup",arItem.id);
			GameInterface.one_itemslist.(attributeName).itemID = arItem.id;
			//if(CheckConsumedItem(arItem.id)) {// TIH doesnt work right?
			if ( sti(GetAttributeValue(curItem)) > 1 ) {// TIH absolute check
				GameInterface.one_itemslist.(attributeName).str1 = "#"+sti(GetAttributeValue(curItem));
			}
// KK -->
			name = "";
			if (CheckAttribute(arItem, "QualityName")) name = TranslateString("", "q"+arItem.QualityName) + " "; // PB: Correct quality name
			name += TranslateString("", arItem.name);
			if(bAnimation) GameInterface.one_itemslist.(attributeName).str2 = "#" + name; // PB: Dynamic Interfaces
// <-- KK
			// TIH --> add equipped checkmarks
			if( IsEquipCharacterByItem(mchref,arItem.id) )
			{
				GameInterface.one_itemslist.(attributeName).img2 = "usedflag";
				GameInterface.one_itemslist.(attributeName).tex2 = 0;
			}
			// TIH <--
		}
		else
		{
			trace("WARNING! Can`t find item ID = "+GetAttributeName(curItem)+" value: "+GetAttributeValue(curItem)+" ");
			GameInterface.one_itemslist.(attributeName).img1 = "itm16";
			GameInterface.one_itemslist.(attributeName).tex1 = 0;
		}
		i++;
    }
	GameInterface.one_itemslist.ListSize = i;

	//============================================================================
	// TRANSFER FROM ITEMS
	//============================================================================
	GameInterface.two_itemslist.NotUsed = 5;
	GameInterface.two_itemslist.current = nCurScroll2;
	makearef(arImgGrp,GameInterface.two_itemslist.ImagesGroup);
	FillImagesGroupForItems(arImgGrp);

	i=0;
	// if the location/character has no gold, create the attribute and set to zero
	if(!CheckAttribute(g_refItems,"Money"))	g_refItems.Money = 0;

	makearef(rootItems,g_refItems.Items);
	q = GetAttributesNum(rootItems);

	// loop through items to find any gold to add to the total
	for(j=0; j<q; j++)
	{
		curItem = GetAttributeN(rootItems,j);
		if(sti(GetAttributeValue(curItem))<=0)	continue;
		if( Items_FindItem(GetAttributeName(curItem),&arItem)>=0 )
		{
			if( CheckAttribute(arItem,"Gold") )
			{
				g_refItems.Money = sti(g_refItems.Money) + sti(arItem.Gold)*GetCharacterItem(g_refItems,arItem.Gold);
				DeleteAttribute(rootItems,arItem.id);
				j--; q--;
			}
		}
	}
	if( sti(g_refItems.Money)>0 )
	{
		GameInterface.two_itemslist.pic1.img1 = GetItemPictureName("Gold");
		GameInterface.two_itemslist.pic1.tex1 = GetItemPictureTexture("two_itemslist.ImagesGroup","Gold");
		GameInterface.two_itemslist.pic1.itemID = "Money";
		GameInterface.two_itemslist.pic1.str1 = "#"+sti(g_refItems.Money);		// LDH 15Oct06 fix for decimal point money
		GameInterface.two_itemslist.pic1.str2 = "Gold"; // KK
		i++;
	}

	// loop through items of the location/character and add to second scroller
	for(j=0; j<q; j++)
	{
		attributeName = "pic" + (i+1);
		curItem = GetAttributeN(rootItems,j);

		if(sti(GetAttributeValue(curItem))<=0)	continue;
		if (GetAttributeName(curItem) == "bladeX4") continue;// TIH simply never show fists in looting screens 7-7-06

		if( Items_FindItem(GetAttributeName(curItem),&arItem)>=0 )
		{
			if(bDeadExchange)
			{
				if(IsCharacterEquipByGroup(g_refItems,BLADE_ITEM_TYPE)) { RemoveCharacterEquip(g_refItems, BLADE_ITEM_TYPE); }
				if(IsCharacterEquipByGroup(g_refItems,GUN_ITEM_TYPE)) { RemoveCharacterEquip(g_refItems, GUN_ITEM_TYPE); }
				if(IsCharacterEquipByGroup(g_refItems,ARMOR_ITEM_TYPE)) { RemoveCharacterEquip(g_refItems, ARMOR_ITEM_TYPE); }
			}
			GameInterface.two_itemslist.(attributeName).img1 = GetItemPictureName(arItem.id);
			GameInterface.two_itemslist.(attributeName).tex1 = GetItemPictureTexture("two_itemslist.ImagesGroup",arItem.id);
			GameInterface.two_itemslist.(attributeName).itemID = arItem.id;
			//if(CheckConsumedItem(arItem.id)) {// TIH doesnt work right?
			if ( sti(GetAttributeValue(curItem)) > 1 ) {// TIH absolute check
				GameInterface.two_itemslist.(attributeName).str1 = "#"+sti(GetAttributeValue(curItem));
			}
// KK -->
			name = "";
			if (CheckAttribute(arItem, "QualityName")) name = TranslateString("", "q"+arItem.QualityName) + " "; // PB: Correct quality name
			name += TranslateString("", arItem.name);
			GameInterface.two_itemslist.(attributeName).str2 = "#" + name;
// <-- KK
		}
		else
		{
			trace("WARNING! Can`t find item ID = "+GetAttributeName(curItem));
			GameInterface.two_itemslist.(attributeName).img1 = "itm16";
			GameInterface.two_itemslist.(attributeName).tex1 = 0;
		}
		i++;
	}
	GameInterface.two_itemslist.ListSize = i;
	if(i==0) noConfirm = true;

	nCurScroll1 = sti(GameInterface.one_itemslist.current);
	nCurScroll2 = sti(GameInterface.two_itemslist.current);
}

void ProcessCancelExit()
{
// changed by MAXIMUS -->
	if(!isItemsBox)
	{
		if(bDeadExchange==true || bEnemyExchange==true || bStealExchange==true)
		{
			if(noConfirm==true) ProcessExit_yes();// TIH procedure fix 7-7-06
			else ProcessExit();
		}
		else
		{
//	        if(oldItemMode==ITEM_MODE_INFO) SetItemMode(ITEM_MODE_SWAP);
//	        else IDoExit(RC_INTERFACE_ITEMSBOX_EXIT);
//	        else
			IDoExit(RC_INTERFACE_DO_RESUME_GAME);
		}
	}
	else
	{
//	    if(oldItemMode==ITEM_MODE_INFO) SetItemMode(ITEM_MODE_SWAP);
//	    else IDoExit(RC_INTERFACE_ITEMSBOX_EXIT);
//	    else
		IDoExit(RC_INTERFACE_DO_RESUME_GAME);
	}
// changed by MAXIMUS <--
}

void IDoExit(int exitCode)
{
	int s; // NK for below for() statements
	if(!g_bIBoxUsed)
	{
		// Aconcagua:
		UpdateSkillModifiers(g_refItems);
		//for(s = 0; s < 10; s++) GetCharacterSkill(g_refItems, GetSkillName(s)); // NK/GZ items mod to force refresh of modifiers.

		DeleteAttribute(&g_refItems, "skiprecalcskill");
		if( GetCharacterSkill(g_refItems,"fencing") > 0 )
		{
			EquipCharacterByItem(g_refItems, FindCharacterItemByGroup(g_refItems,BLADE_ITEM_TYPE));
			EquipCharacterByItem(g_refItems, FindCharacterItemByGroup(g_refItems,GUN_ITEM_TYPE));
			EquipCharacterByItem(g_refItems, FindCharacterItemByGroup(g_refItems,ARMOR_ITEM_TYPE)); // NK
			EquipCharacterByItem(g_refItems, FindCharacterItemByGroup(g_refItems,FLASK_ITEM_TYPE)); //JRH
			EquipCharacterByItem(g_refItems, FindCharacterItemByGroup(g_refItems,POUCH_ITEM_TYPE)); //JRH
		}
	}

	// Aconcagua:
	UpdateSkillModifiers(GetMainCharacter());
	//for(s = 0; s < 10; s++) GetCharacterSkill(GetMainCharacter(), GetSkillName(s)); // NK/GZ items mod to force refresh of modifiers.

	DeleteAttribute(GetMainCharacter(), "skiprecalcskill");
	DelEventHandler("InterfaceBreak","ProcessCancelExit");
	DelEventHandler("exitCancel","ProcessCancelExit");
	DelEventHandler("frame","FrameProcess");
	DelEventHandler("ievnt_command","ProcInterfaceCommand");
// added by MAXIMUS -->
	DelEventHandler("ExitPress","ProcessExit");
	DelEventHandler("ExitNo","ProcessExit_no");
	DelEventHandler("ExitYes","ProcessExit_yes");
// added by MAXIMUS <--

// KK -->
	bDeadExchange = false;
	bEnemyExchange = false;
	bStealExchange = false;
// <-- KK

    interfaceResultCommand = exitCode;

// LDH - go back to Character screen if exchange called from there.
	if (CheckAttribute(GetMainCharacter(), "ExchangeItemsFromCharacterScreen"))
	{
		PostEvent("LaunchIAfterFrame",1,"sl", "I_CHARACTER", 1);
	    EndCancelInterface(false);
		return;
	}
	else
	{
		EndCancelInterface(true);	// original code
	}

	SetTimeScale(1.0);
	locCameraSleep(false);
	BLIVisible(true);
	if(interfaceResultCommand == RC_INTERFACE_DO_RESUME_GAME) { DeleteEntitiesByType("scrshoter"); }
}

void IGotoNewNode(string newNode)
{
	if(oldNodeName==newNode) return;
	oldNodeName=newNode;
	if(newNode=="ONE_ITEMSLIST")	SetScroll(true);
	if(newNode=="TWO_ITEMSLIST")	SetScroll(false);

	if(oldItemMode!=ITEM_MODE_SWAP)
	{
		if(newNode!="DESCRIBEWINDOW")
		{
			SetItemMode(ITEM_MODE_SWAP);
			SetUpDownUsed();
		}
	}
}

void SetScroll(bool bIsOne)
{
	if(bIsOne)
	{
		if(oldCurScrollName=="TWO_ITEMSLIST")
		{
			SetNodeUsing("TWO_LEFTSCROLLBUTTON",false);
			SetNodeUsing("TWO_RIGHTSCROLLBUTTON",false);
		}
		SetNodeUsing("ONE_LEFTSCROLLBUTTON",true);
		SetNodeUsing("ONE_RIGHTSCROLLBUTTON",true);
		oldCurScrollName = "ONE_ITEMSLIST";
	}
	else
	{
		if(oldCurScrollName=="ONE_ITEMSLIST")
		{
			SetNodeUsing("ONE_LEFTSCROLLBUTTON",false);
			SetNodeUsing("ONE_RIGHTSCROLLBUTTON",false);
		}
		SetNodeUsing("TWO_LEFTSCROLLBUTTON",true);
		SetNodeUsing("TWO_RIGHTSCROLLBUTTON",true);
		oldCurScrollName = "TWO_ITEMSLIST";
	}
}

void SetItemMode(int mode)
{
	switch(oldItemMode)
	{
	case ITEM_MODE_SWAP:
		SetNodeUsing("INFO_BUTTON",false);
		SetNodeUsing("SWAP_BUTTON",false);
		SetNodeUsing("ONEUP_BUTTON",false);
		SetNodeUsing("ONEDOWN_BUTTON",false);
		SetNodeUsing("ALLUP_BUTTON",false);
		SetNodeUsing("ALLDOWN_BUTTON",false);
	break;
	//case ITEM_MODE_INFO:	SetNodeUsing("DESCRIBEWINDOW",false);	break;
	}

	oldItemMode = mode;

	switch(mode)
	{
	case ITEM_MODE_SWAP:
		SetNodeUsing("INFO_BUTTON",true);
		SetNodeUsing("SWAP_BUTTON",true);
		SetNodeUsing("ONEUP_BUTTON",true);
		SetNodeUsing("ONEDOWN_BUTTON",true);
		SetNodeUsing("ALLUP_BUTTON",true);
		SetNodeUsing("ALLDOWN_BUTTON",true);
	break;
	//case ITEM_MODE_INFO:	SetNodeUsing("DESCRIBEWINDOW",true);	break;
	}
}

void ProcInterfaceCommand()
{
	string comName = GetEventData();
	string nodeName = GetEventData();
	int scrollstep = 0;

// KK -->
	if (bRMouseDown) {
		if (comName != "click") return;

		ShowDescription(nodeName);
		return;
	}

	if (HasSubStr(nodeName, "AITEM1_")) {
		scrollstep = sti(strcut(nodeName, 7, strlen(nodeName) - 1));
		nodeName = "ONE_ITEMSLIST";
	}
	if (HasSubStr(nodeName, "AITEM2_")) {
		scrollstep = sti(strcut(nodeName, 7, strlen(nodeName) - 1));
		nodeName = "TWO_ITEMSLIST";
	}
// <-- KK

	switch(nodeName)
	{
	/*case "INFO_BUTTON":
		if(comName=="upstep") {GoToTopScroll();}
		if(comName=="downstep") {GoToBottomScroll();}
		if(comName=="rightstep") {SelectButtonRight("ONEDOWN_BUTTON");}
		if(comName=="deactivate")	{SetCurrentNode(oldCurScrollName);}
// KK -->
		if(comName=="activate" || comName=="click")
		{
			//SetItemMode(ITEM_MODE_INFO);
			//SetDescribeText();
			//SetCurrentNode("DESCRIBEWINDOW");
			ShowDescription(true);
		}
// <-- KK
	break;*/

// KK -->
	/*case "SHOW_DESCRIPTION_OK_BUTTON":
		if(comName == "activate" || comName == "click" || comName == "deactivate")
		{
			ShowDescription(false);
		}
	break;*/
// <-- KK

	case "ONEDOWN_BUTTON":
		if(comName=="upstep") {GoToTopScroll();}
		if(comName=="downstep") {GoToBottomScroll();}
		if(comName=="leftstep") {SelectButtonLeft("INFO_BUTTON");}
		if(comName=="rightstep") {SelectButtonRight("ONEUP_BUTTON");}
		if(comName=="activate" || comName=="click")	{GiveOneItem();}
		if(comName=="deactivate")	{SetCurrentNode(oldCurScrollName);}
	break;

	case "ONEUP_BUTTON":
		if(comName=="upstep") {GoToTopScroll();}
		if(comName=="downstep") {GoToBottomScroll();}
		if(comName=="leftstep") {SelectButtonLeft("ONEDOWN_BUTTON");}
		if(comName=="rightstep") {SelectButtonRight("SWAP_BUTTON");}
		if(comName=="activate" || comName=="click")	{TakeOneItem();}
		if(comName=="deactivate")	{SetCurrentNode(oldCurScrollName);}
	break;

	case "SWAP_BUTTON":
		if(comName=="upstep") {GoToTopScroll();}
		if(comName=="downstep") {GoToBottomScroll();}
		if(comName=="leftstep") {SelectButtonLeft("ONEUP_BUTTON");}
		if(comName=="rightstep") {SelectButtonRight("ALLUP_BUTTON");}
		if(comName=="activate" || comName=="click")	{ChangeItemsSlot();}
		if(comName=="deactivate")	{SetCurrentNode(oldCurScrollName);}
	break;

	case "ALLUP_BUTTON":
		if(comName=="upstep") {GoToTopScroll();}
		if(comName=="downstep") {GoToBottomScroll();}
		if(comName=="leftstep") {SelectButtonLeft("SWAP_BUTTON");}
		if(comName=="rightstep") {SelectButtonRight("ALLDOWN_BUTTON");}
		if(comName=="activate" || comName=="click")	{TakeItemsCollection();}
		if(comName=="deactivate")	{SetCurrentNode(oldCurScrollName);}
	break;

	case "ALLDOWN_BUTTON":
		if(comName=="upstep") {GoToTopScroll();}
		if(comName=="downstep") {GoToBottomScroll();}
		if(comName=="leftstep") {SelectButtonLeft("ALLUP_BUTTON");}
		if(comName=="activate" || comName=="click")	{GiveItemsCollection();}
		if(comName=="deactivate")	{SetCurrentNode(oldCurScrollName);}
	break;

	case "ONE_ITEMSLIST":
		if(comName=="downstep")	{SelectButtonLeft("SWAP_BUTTON");}
		if (comName == "click" || comName == "activate") {
			GoToTopScroll();
			nCurScroll1 += scrollstep;
			GameInterface.ONE_ITEMSLIST.current = nCurScroll1;
			SendMessage(&GameInterface, "lsl", MSG_INTERFACE_SCROLL_CHANGE, "ONE_ITEMSLIST", nCurScroll1);
			SendMessage(&GameInterface,"ls", MSG_INTERFACE_REFRESH_SCROLL, "ONE_ITEMSLIST");
		}
	break;

	case "TWO_ITEMSLIST":
		if(comName=="upstep")	{SelectButtonLeft("SWAP_BUTTON");}
		if (comName == "click" || comName == "activate") {
			GoToBottomScroll();
			nCurScroll2 += scrollstep;
			GameInterface.TWO_ITEMSLIST.current = nCurScroll2;
			SendMessage(&GameInterface, "lsl", MSG_INTERFACE_SCROLL_CHANGE, "TWO_ITEMSLIST", nCurScroll2);
			SendMessage(&GameInterface,"ls", MSG_INTERFACE_REFRESH_SCROLL, "TWO_ITEMSLIST");
		}
	break;

	/*case "DESCRIBEWINDOW":
		if(comName=="downstep")
		{
			if(!bEnableDown)
			{
				SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"DESCRIBEWINDOW",-1, 0,ACTION_UPSTEP);
			} else {
				bEnableDown = SendMessage(&GameInterface,"lsll",MSG_INTERFACE_MSG_TO_NODE,"DESCRIBEWINDOW", 6, 0);
			}
		}
		if(comName=="upstep")
		{
			bEnableDown = SendMessage(&GameInterface,"lsll",MSG_INTERFACE_MSG_TO_NODE,"DESCRIBEWINDOW", 6, 0);
		}
	break;*/
	}
}

void ChangeItemsSlot()
{
	string itm1 = GetItemIDByOrder(true,nCurScroll1);
	string itm2 = GetItemIDByOrder(false,nCurScroll2);
	string itm1name = "";                // Sulan: Quicker Inventory
	string itm2name = "";                // Sulan: Quicker Inventory
	aref aritem;                         // Sulan: Quicker Inventory
	int limit;

	if(itm1=="" || itm1!=itm2)
	{
		if( !CanCharacterTakeItem(true,itm2) ) return;
	}

	int iq1 = GetItemQntByOrder(true,nCurScroll1);
	int iq2 = GetItemQntByOrder(false,nCurScroll2);

	aref mchref; makearef(mchref,Characters[GetMainCharacterIndex()]);

	if(iq1>0)
	{
		if(itm1=="Money")
		{
			mchref.Money = 0;
			g_refItems.Money = iq1+sti(g_refItems.Money);
		}
		else
		{ // --> Sulan 07/2010: Check for quantity limits
			if(itm1=="pistolbullets" || itm1=="pistolgrapes" || itm1=="musketbullets" || itm1=="gunpowder")
			{
				limit = HowManyItemsCanITake(itm1, g_refitems);
				if (limit < iq1) iq1 = limit;
			}
			if(iq1 >0)
			{
				TakeNItems(GetMainCharacter(),itm1,-iq1);
				if( CheckAttribute(g_refItems,"Items."+itm1) )
				{
					iq1 = iq1 + sti(g_refItems.Items.(itm1));
				}
			g_refItems.Items.(itm1) = iq1;
			}
		} // <--
	}
	if(iq2>0)
	{
		if(itm2=="Money")
		{
			g_refItems.Money = sti(g_refItems.Money)-iq2;
			mchref.Money = iq2+sti(mchref.Money);			
		}
		else
		{
			if(itm2=="pistolbullets" || itm2=="pistolgrapes" || itm2=="musketbullets" || itm2=="gunpowder")
			{
				limit = HowManyItemsCanITake(itm2, mchref);
				if (limit < iq2) iq2 = limit;
			}
			if(iq2>0)
			{
				TakeNItems(GetMainCharacter(),itm2,iq2);
				g_refItems.Items.(itm2) = sti(g_refItems.Items.(itm2))-iq2;
				if( sti(g_refItems.Items.(itm2))<=0 ) DeleteAttribute(g_refItems,"Items."+itm2);
			}
		}
	}

	// Sulan: Quicker Inventory  -->
	//FillScroll();
	if( Items_FindItem(itm1,&arItem)>=0 )
	{
		itm1name = "#";
		if (CheckAttribute(arItem, "QualityName")) itm1name += TranslateString("", "q"+arItem.QualityName) + " "; 

		itm1name += TranslateString("", arItem.name);
	}
	if( Items_FindItem(itm2,&arItem)>=0 )
	{
		itm2name = "#";
		if (CheckAttribute(arItem, "QualityName")) itm2name += TranslateString("", "q"+arItem.QualityName) + " "; 
		itm2name += TranslateString("", arItem.name);
	}
	InsertItem( 0, itm1, iq1, itm1name);
	InsertItem( 1, itm2, iq2, itm2name);
	RemoveItem( 0, itm1, iq1);
	RemoveItem( 1, itm2, iq2);
	// <-- Sulan
	SendMessage(&GameInterface,"lsl",MSG_INTERFACE_SCROLL_CHANGE,"ONE_ITEMSLIST",-1);
	SendMessage(&GameInterface,"lsl",MSG_INTERFACE_SCROLL_CHANGE,"TWO_ITEMSLIST",-1);
	SetUpDownUsed();
	SetScrollsUsing();
}

// Sulan: Rewrote these functions to reduce the code mess :)
void TakeOneItem()
{
	TakeItems(false);
}
void GiveOneItem()
{
	GiveItems(false);
}
void TakeItemsCollection()
{
	TakeItems(true);
}
void GiveItemsCollection()
{
	GiveItems(true);
}

void GiveItems(bool bMoreThanOneItem)
{
	string itm1 = GetItemIDByOrder(true,nCurScroll1);
	string itm1name;
	int iq1 = GetItemQntByOrder(true,nCurScroll1);
	bool takeitem = false;
	int limit;
	int newQty;
	int amount;
	aref aritem;
	aref mchref; makearef(mchref,Characters[GetMainCharacterIndex()]);

	if(iq1<=0) return;
	if(!bMoreThanOneItem) amount = 1;
	else amount = iq1;

	if(itm1=="Money")
	{
		if(bMoreThanOneItem)
		{
			mchref.Money = 0;
			g_refItems.Money = sti(g_refItems.Money)+amount;
			takeitem = true;
		}
		else
		{
			if(iq1 >= GOLD_PER_CLICK)
			{
				amount = GOLD_PER_CLICK;
				iq1 = iq1 - GOLD_PER_CLICK;
				mchref.Money = sti(mchref.Money) - GOLD_PER_CLICK;
				g_refItems.Money = sti(g_refItems.Money) + GOLD_PER_CLICK;
			}
			else
			{
				iq1 = 0;
				amount = sti(mchref.Money);
				g_refItems.Money = sti(g_refItems.Money) + sti(mchref.Money);
				mchref.Money = 0;
			}
			takeitem = true;
		}
	}
	else
	{ // for bullets and gunpowder follow the quantity restrictions
		if (itm1=="gunpowder" || itm1=="pistolbullets" || itm1=="pistolgrapes" || itm1=="musketbullets")
		{
			limit = HowManyItemsCanITake(itm1, g_refItems);
			if (limit < amount) amount = limit;
			if(amount >0) takeitem = true;
			if(CANNONPOWDER_MOD && isGunpowder)
			{
				if(bAbordageStarted && !bCabinStarted && !bDeckStarted && !bCrewStarted)
				{
					newQty = sti(GetCargoGoods(boarding_enemy, GOOD_GUNPOWDER))-1;
					SetCharacterGoods(boarding_enemy, GOOD_GUNPOWDER, newQty);
				}
				else
				{
					newQty = sti(GetCargoGoods(GetMainCharacter(), GOOD_GUNPOWDER))-1;
					if(bDeckStarted) SetCharacterGoods(GetMainCharacter(), GOOD_GUNPOWDER, newQty);
				}
			}
		}
		else takeitem = true; // for any other item: just give it away
		if(takeitem)
		{
			TakeNItems(GetMainCharacter(),itm1,-amount);
			if( CheckAttribute(g_refItems,"Items."+itm1) )
			g_refItems.Items.(itm1) = amount + sti(g_refItems.Items.(itm1));
			else	g_refItems.Items.(itm1) = amount;
		}
	}
	// Sulan: Quicker Inventory  -->
	// FillScroll();
	if(takeitem)
	{
		if( Items_FindItem(itm1,&arItem)>=0 )
		{
			itm1name = "#";
			if (CheckAttribute(arItem, "QualityName")) itm1name += TranslateString("", "q"+arItem.QualityName) + " ";
			itm1name += TranslateString("", arItem.name);
	  	}
		MoveItem( 0, itm1, amount, itm1name);
		// <-- Sulan
		SendMessage(&GameInterface,"lsl",MSG_INTERFACE_SCROLL_CHANGE,"ONE_ITEMSLIST",-1);
		SendMessage(&GameInterface,"lsl",MSG_INTERFACE_SCROLL_CHANGE,"TWO_ITEMSLIST",-1);
		SetUpDownUsed();
		SetScrollsUsing();
	}
}

void TakeItems(bool bMoreThanOneItem)
{
	string itm2 = GetItemIDByOrder(false,nCurScroll2);
	string itm2name;
	int iq2 = GetItemQntByOrder(false,nCurScroll2);
	int newQty;
	bool takeitem = false;
	int limit;
	int amount;
	aref aritem;
	aref mchref; makearef(mchref,Characters[GetMainCharacterIndex()]);

	if(iq2<=0) return;
	if(!bMoreThanOneItem) amount = 1;
	else amount = iq2;

	if(itm2=="Money")
	{
		if(bMoreThanOneItem)
		{
			mchref.Money = sti(mchref.Money)+amount;
			g_refItems.Money = 0;
			takeitem=true;
		}
		else
		{
			if(iq2 >= GOLD_PER_CLICK)
			{
				amount = GOLD_PER_CLICK;
				iq2 = iq2 - GOLD_PER_CLICK;
				mchref.Money = sti(mchref.Money) + GOLD_PER_CLICK;
				g_refItems.Money = iq2;
			}
			else
			{
				amount = iq2;
				mchref.Money = sti(mchref.Money) + iq2;
				iq2 = 0;
				g_refItems.Money = 0;
			}
			takeitem=true;
		}
	}
	else
	{ // for bullets and gunpowder follow the quantity restrictions
		if(itm2=="pistolbullets" || itm2=="pistolgrapes" || itm2=="musketbullets" || itm2=="gunpowder")
		{
			limit = HowManyItemsCanITake(itm2, mchref);
			if (limit < amount) amount = limit;
			if(amount >0) takeitem = true;
			if(CANNONPOWDER_MOD && isGunpowder)
			{
				if(bAbordageStarted && !bCabinStarted && !bDeckStarted && !bCrewStarted)
				{
					newQty = sti(GetCargoGoods(boarding_enemy, GOOD_GUNPOWDER))-1;
					SetCharacterGoods(boarding_enemy, GOOD_GUNPOWDER, newQty);
				}
				else
				{
					newQty = sti(GetCargoGoods(GetMainCharacter(), GOOD_GUNPOWDER))-1;
					if(bDeckStarted) SetCharacterGoods(GetMainCharacter(), GOOD_GUNPOWDER, newQty);
				}
			}
		}
		else takeitem = true;		 // for any other item: just take it
		if(takeitem)
		{
			TakeNItems(GetMainCharacter(),itm2,amount);
			g_refItems.Items.(itm2) = sti(g_refItems.Items.(itm2))-amount;
			if( (g_refItems.Items.(itm2)-amount)<=0 ) DeleteAttribute(g_refItems,"Items."+itm2);
		}
	}
	// Sulan: Quicker Inventory  -->
	// FillScroll();
	if(takeitem)
	{
		if( Items_FindItem(itm2,&arItem)>=0 )
		{
			itm2name = "#";
			if (CheckAttribute(arItem, "QualityName")) itm2name += TranslateString("", "q"+arItem.QualityName) + " ";
			itm2name += TranslateString("", arItem.name);
		}
		MoveItem( 1, itm2, amount, itm2name);
		// <-- Sulan
		SendMessage(&GameInterface,"lsl",MSG_INTERFACE_SCROLL_CHANGE,"ONE_ITEMSLIST",-1);
		SendMessage(&GameInterface,"lsl",MSG_INTERFACE_SCROLL_CHANGE,"TWO_ITEMSLIST",-1);
		SetUpDownUsed();
		SetScrollsUsing();
	}
}

// Sulan 07/2010: Function to return the maximum number of bullets or gunpowder
// units which the specified character can take
int HowManyItemsCanITake(string item_ID, ref _refchar)
{
	int i;
	int gp;	// gunpowder
	int pb; // pistol bullets
	int pg; // pistol grapes
	int mb; // musket bullets
	int tb; // total bullet count
	int p;  // max number of gunpowder units
	int s;  // max number of shots

	if(IsOfficer(_refchar) || IsMainCharacter(_refchar))
	{
		gp = GetCharacterItem(_refchar, "gunpowder");
		pb = GetCharacterItem(_refchar, "pistolbullets");
		pg = GetCharacterItem(_refchar, "pistolgrapes");
		mb = GetCharacterItem(_refchar, "musketbullets");
		tb = pb + pg + 2*mb;  // musket bullets count double

		if(CheckAttribute(_refchar,"equip."+FLASK_ITEM_TYPE))	p = (2 * MAX_GUNPOWDER);
		else p = MAX_GUNPOWDER;	 
		if(CheckAttribute(_refchar,"equip."+POUCH_ITEM_TYPE) ) s = (2* MAX_SHOTS);
		else s = MAX_SHOTS;

    // For Officers
    if(IsOfficer(_refchar))
    {
      if(CheckCharacterItem(_refchar,"powderflask")) p = (2 * MAX_GUNPOWDER);
      else p = MAX_GUNPOWDER;	 
		  if(CheckCharacterItem(_refchar,"ammopouch")) s = (2* MAX_SHOTS);
		  else s = MAX_SHOTS;
    }

		switch(item_ID)
		{
			case "gunpowder":
				if( gp < p ) i = (p-gp);
				else i=0;
			break;
			case "pistolbullets":
				if(tb < s) i = (s-tb);
				else i=0;
			break;
			case "pistolgrapes":
				if(tb < s) i = (s-tb);
				else i=0;
			break;
			case "musketbullets":
				if(tb < (s-1)) i = ((s-tb)/2);
				else i =0;
			break;
		}
	}
	else
	{
		switch(item_ID)
		{
			case "gunpowder":
				i = 1000000;
			break;
			case "pistolbullets":
				i = 1000;
			break;
			case "pistolgrapes":
				i = 1000;
			break;
			case "musketbullets":
				i = 1000;
			break;
		}
	}
	return i;
}

void InsertItem(int source_itemlist, string source_itemID, int amount, string str2)
{
	string sourceItem;    // name of the item in the array to be deleted
	string tempItem;    // name of the following item in the array
	int i;
	int j;
	int newamount;
	string tempStr1;
	aref list;
	string listname;

	if (amount <= 0) return;

	switch(source_itemlist)
	{
		case 0:                                       // insert into chest
			makearef(list,GameInterface.two_itemslist);
			listname="two_itemslist";
		break;
		case 1:                                       // insert into inventory
			makearef(list,GameInterface.one_itemslist);
			listname="one_itemslist";
		break;
	}  
	j = list.ListSize;
	for(i=1; i<=j;i++)   // check, if such item is already in the list
	{
		tempItem = "pic" + i;
		
    // -> Sulan: Debug trace to identify invalid items (such without itemID)
		if(!CheckAttribute(&GameInterface,listname+"."+tempItem+".ItemID")) trace("Itemsbox.c invalid item: "+tempItem+" source list: "+source_itemlist);
		// <- Sulan
		
    if (list.(tempItem).ItemID == source_itemID )
		{
			if(CheckAttribute(&GameInterface, listname+"."+tempItem+".str1")) // if more than one item already in destination list
			{
				tempStr1 =  striphash(list.(tempItem).str1);
				if(tempStr1=="")
				{
				newamount = 1 + amount;
				}
				else
				{
					newamount = sti(tempStr1) + amount;
				}
			}
			else   // only one item in destination list
			{
				newamount = 1 + amount;
			}
			list.(tempItem).str1 = "#" + newamount;
			SendMessage(&GameInterface, "ls", MSG_INTERFACE_REFRESH_SCROLL, listname);
			return;
		}
	}
	// if item is not in the list, add it
	tempItem = "pic" + i;
	if(source_itemID == "Money")
	{
    list.(tempItem).img1 = GetItemPictureName("Gold");
    list.(tempItem).tex1 = GetItemPictureTexture(listname+".ImagesGroup","Gold");
    list.(tempItem).str2 = "Gold";
  }
  else
  {
    list.(tempItem).img1 = GetItemPictureName(source_itemID);
    list.(tempItem).tex1 = GetItemPictureTexture(listname+".ImagesGroup",source_itemID);
    list.(tempItem).str2 = str2;
  }
	list.(tempItem).ItemID = source_itemID;
	if (amount > 1) list.(tempItem).str1 = "#"+amount;
	else list.(tempItem).str1 = "";
	list.ListSize = i;
	SendMessage(&GameInterface, "ls", MSG_INTERFACE_REFRESH_SCROLL, listname);
}

void RemoveItem(int item_list, string item_ID, int amount)
{
	string oldItem;    // name of the item in the array to be deleted
	string newItem;    // name of the following item in the array
	string tempItem;
	aref list;
	string listname;
	int i, j, k;
	int item_no;
	int scroll_pos;
	int temp;

	if (amount <= 0) return;

	switch(item_list)
	{
		case 0:                                                                      // is the Player's inventory (upper scrollbar)
			makearef(list,GameInterface.one_itemslist);
			listname="one_itemslist";
		break;
		case 1:
			makearef(list,GameInterface.two_itemslist);
			listname="two_itemslist";
		break;
	}
	j = list.ListSize;
	for(k=1; k <=j;k++)
	{
		tempItem = "pic" + k;
		
		// -> Sulan: Debug trace to identify invalid items (such without itemID)
		if(!CheckAttribute(&GameInterface,listname+"."+tempItem+".ItemID")) trace("Itemsbox.c invalid item: "+tempItem+" source list: "+item_list);
		// <- Sulan
		
		if(list.(tempItem).itemID == item_ID)
		{
			item_no = k;
			break;
		}
	}
	if(CheckAttribute(&GameInterface, listname+"."+tempItem+".str1"))
	{
		temp = sti(striphash(list.(tempItem).str1));
	}
	else
	{
		temp = 1;
	}
	if(amount<temp)   // if there are more items in the list than to be removed
	{
		if((temp-amount)>1)
		{
			list.(tempItem).str1 = "#"+(temp-amount);
		}
		else
		{
			list.(tempItem).str1 = "";
		}
	}
	else
	{
		if (j==item_no)                                 // if item is the last item in list
		{
			newItem = "pic" + item_no;
			i = list.ListSize;
		}
		else
		{
			for(i=item_no; i < j ; i++)                   // move all items to the left
			{
				temp = i+1;
				oldItem = "pic" + i;
				newItem = "pic" + temp;

				list.(olditem).img1 = list.(newItem).img1;
				list.(olditem).tex1 = list.(newItem).tex1;	
				list.(olditem).itemID = list.(newItem).itemID;
				if(CheckAttribute(&GameInterface, listname+"."+newItem+".str1"))  list.(olditem).str1 = list.(newItem).str1;	
				else list.(olditem).str1 = "";
				if(CheckAttribute(&GameInterface, listname+"."+newItem+".img2"))  list.(olditem).img2 = list.(newItem).img2;
				else list.(olditem).img2 = "";
				if(CheckAttribute(&GameInterface, listname+"."+newItem+".tex2"))  list.(olditem).tex2 = list.(newItem).tex2;
				else list.(olditem).tex2 = "";
				list.(olditem).str2 = list.(newItem).str2;
			}
		}
		if(CheckAttribute(&GameInterface,listname+".current")) scroll_pos = (sti(list.current)+1);
		if (scroll_pos>=j)
		{
			list.current = (scroll_pos-2);
		}
		DeleteAttribute(&GameInterface,listname+"." + newItem);        //delete last item
		if (i>=1) {list.ListSize = i-1;}
	}
	if(list.ListSize==0 && item_list==1) noConfirm = true;
	SendMessage(&GameInterface, "ls", MSG_INTERFACE_REFRESH_SCROLL, listname);
}

void MoveItem(int source_itemlist, string source_itemID, int amount, string str2 )
{
	InsertItem( source_itemlist, source_itemID, amount, str2);
	RemoveItem( source_itemlist, source_itemID, amount);
}

void GetDescribeData(int iScroll, int iRect, ref nameStr, ref descrStr, ref picStr, ref texStr)
{
	aref arItem;
	//string descrStr = "";
	string Quality = ""; // NK
	bool bYesDescribe = false;

// KK -->
	nameStr = "";
	descrStr = "";
	picStr = "";
	texStr = "";
// <-- KK

	if (iScroll == 1) bYesDescribe = GetItemRefByOrder(true, nCurScroll1 + iRect, &arItem);
	if (iScroll == 2) bYesDescribe = GetItemRefByOrder(false,nCurScroll2 + iRect, &arItem);

	if( !bYesDescribe ) {
		// KK SetFormatedText("DESCRIBEWINDOW","");
		bEnableDown = false;
		return;
	}
	// NK -->
	if( CheckAttribute(arItem,"name") ) // NK, was checking attr "describe"
	{
		nameStr = TranslateString("",arItem.name);
	}
	// NK <--
	if( CheckAttribute(arItem,"groupID") )
	{
		// NK -->
		// LDH added quality "q" translation string - 07May09
		if (CheckAttribute(arItem,"QualityName")) { Quality = arItem.QualityName; nameStr = TranslateString("","q"+Quality) + " " + nameStr; }
		//GameInterface.strings.itemname = descrStr;
		//descrStr += newLineStr;
		// NK <--
		if(arItem.groupID==GUN_ITEM_TYPE)
		{
			descrStr = GetAssembledString(TranslateString("","weapon gun parameters"), arItem);
		}
		if(arItem.groupID==BLADE_ITEM_TYPE)
		{
			descrStr = GetAssembledString(TranslateString("","weapon blade parameters"), arItem);
		}
		// GreatZen -->
		if(arItem.groupID==ARMOR_ITEM_TYPE)
		{
			descrStr = GetAssembledString(TranslateString("","weapon armor parameters"),arItem);
		}
		// GreatZen <--
	}
	if( CheckAttribute(arItem,"describe") )
	{
		if(descrStr!="") { descrStr += GlobalStringConvert("newline"); }
		descrStr += TranslateString("",arItem.describe) + GetItemBonuses(arItem.id); // NK
	}

	picStr = GetItemPictureName(arItem.id);
	texStr = GetItemTextureName(arItem.id);

	// KK SetFormatedText("DESCRIBEWINDOW",descrStr);
	//bEnableDown = SendMessage(&GameInterface,"lsll",MSG_INTERFACE_MSG_TO_NODE,"DESCRIBEWINDOW", 6, 0);
	//return;
}

//==============================
// items utilites
//==============================
string GetItemIDByOrder(bool my,int num)
{
	string attrName = "pic"+(num+1);
	if(my)
	{
		if( CheckAttribute(&GameInterface,"one_itemslist."+attrName+".itemID") )
			return GameInterface.one_itemslist.(attrName).itemID;
	}
	else
	{
		if( CheckAttribute(&GameInterface,"two_itemslist."+attrName+".itemID") )
			return GameInterface.two_itemslist.(attrName).itemID;
	}
	return "";
}

bool GetItemRefByOrder(bool my,int num, ref refItem)
{
	aref ar;
	string itemID = GetItemIDByOrder(my,num);
	if(itemID=="Money") itemID=GOLD;
	if( Items_FindItem(itemID,&ar)<0 ) return false;
	refItem = ar;
	return true;
}

int GetItemQntByOrder(bool my,int num)
{
	string itmName = GetItemIDByOrder(my,num);
	if(my)
	{
		if(itmName=="Money")
		{
			return sti(Characters[GetMainCharacterIndex()].Money);
		}
		return GetCharacterItem(GetMainCharacter(),itmName);
	}
	if(itmName=="Money") return sti(g_refItems.Money);
	if( CheckAttribute(g_refItems,"items."+itmName) )
		return sti(g_refItems.items.(itmName));
	return 0;
}

bool CheckConsumedItem(string itemID)
{
	aref arone;
	makearef(arone,Characters[GetMainCharacterIndex()].items);
	aref artwo;
	makearef(artwo,g_refItems.items);

	int n=0;
	if( CheckAttribute(arone,itemID) ) n = sti(arone.(itemID));
	if( CheckAttribute(artwo,itemID) ) n = n + sti(artwo.(itemID));

	if(n>1) return true;
	return false;
}

bool CanCharacterTakeItem(bool myCh,string itemName)
{
	if(!myCh) return true;
	aref chref = GetMainCharacter();
//	makearef(chref,Characters[GetMainCharacterIndex()]);
	if( CheckAttribute(chref,"items."+itemName) ) return true;
	if( GetChrItemQuantity(GetMainCharacter())<MAX_ITEM_TAKE ) return true;
	return false;
}

void SetUpDownUsed()
{
	aref iref; makearef(iref,Characters[GetMainCharacterIndex()].items);

	string itmName1 = GetItemIDByOrder(true,nCurScroll1);
	int iq1 = GetItemQntByOrder(true,nCurScroll1);
	string itmName2 = GetItemIDByOrder(false,nCurScroll2);
	int iq2 = GetItemQntByOrder(false,nCurScroll2);

	if(iq1<=0)
	{
		SetSelectable("ONEDOWN_BUTTON",false);
		SetSelectable("ALLDOWN_BUTTON",false);
	}
	else
	{
		SetSelectable("ONEDOWN_BUTTON",true);
		SetSelectable("ALLDOWN_BUTTON",true);
	}

	if(iq2<=0)
	{
		SetSelectable("ONEUP_BUTTON",false);
		SetSelectable("ALLUP_BUTTON",false);
	}
	else
	{
		if( CheckAttribute(iref,itmName2) || GetAttributesNum(iref)<MAX_ITEM_TAKE )
		{
			SetSelectable("ONEUP_BUTTON",true);
			SetSelectable("ALLUP_BUTTON",true);
		}
		else
		{
			SetSelectable("ONEUP_BUTTON",false);
			SetSelectable("ALLUP_BUTTON",false);
		}
	}

	if(itmName2=="" || itmName2=="Money" || GetAttributesNum(iref)<MAX_ITEM_TAKE)
	{
		SetSelectable("SWAP_BUTTON",true);
	}
	else
	{
		if( CheckAttribute(iref,itmName2) )	SetSelectable("SWAP_BUTTON",true);
		else
		{
			if(itmName1!="" && itmName1!="Money") SetSelectable("SWAP_BUTTON",true);
			else SetSelectable("SWAP_BUTTON",false);
		}
	}

	if( IsQuestUsedItem(itmName1) )
	{
		SetSelectable("ONEDOWN_BUTTON",false);
		SetSelectable("ALLDOWN_BUTTON",false);
		SetSelectable("SWAP_BUTTON", false); // Aconcagua
	}

	if (ENABLE_AMMOMOD) {// TIH --> mod toggle 7-7-06
		// added by MAXIMUS [for gunpowder barrels] -->
		if(isGunpowder)
		{// MAXIMUS 21.07.2006: checking for bullets
			if(GetItemIDByOrder(true,nCurScroll1) != "gunpowder" && GetItemIDByOrder(true,nCurScroll1) != "pistolgrapes" && GetItemIDByOrder(true,nCurScroll1) != "pistolbullets" && GetItemIDByOrder(true,nCurScroll1) != "musketbullets")
			{
				SetSelectable("ONEDOWN_BUTTON",false);
				SetSelectable("ALLDOWN_BUTTON",false);
			}
			SetSelectable("SWAP_BUTTON",false);
		}
		// added by MAXIMUS [for gunpowder barrels] <--
	}// TIH <-- mod toggle

	ThatOneAndEquiped(itmName1,itmName2);

	if(!GetSelectable(GetCurrentNode()))	SetCurrentNode(oldCurScrollName);
}

void SelectButtonLeft(string startBtnNode)
{
	if(GetSelectable(startBtnNode))	SetCurrentNode(startBtnNode);
	else
	{
		switch(startBtnNode)
		{
		case "ONEDOWN_BUTTON":	SelectButtonLeft("INFO_BUTTON"); break;
		case "ONEUP_BUTTON":	SelectButtonLeft("ONEDOWN_BUTTON"); break;
		case "SWAP_BUTTON":		SelectButtonLeft("ONEUP_BUTTON"); break;
		case "ALLUP_BUTTON":	SelectButtonLeft("SWAP_BUTTON"); break;
		case "ALLDOWN_BUTTON":	SelectButtonLeft("ALLUP_BUTTON"); break;
		}
	}
}

void SelectButtonRight(string startBtnNode)
{
	if(GetSelectable(startBtnNode))	SetCurrentNode(startBtnNode);
	else
	{
		switch(startBtnNode)
		{
		case "INFO_BUTTON":		SelectButtonRight("ONEDOWN_BUTTON"); break;
		case "ONEDOWN_BUTTON":	SelectButtonRight("ONEUP_BUTTON"); break;
		case "ONEUP_BUTTON":	SelectButtonRight("SWAP_BUTTON"); break;
		case "SWAP_BUTTON":		SelectButtonRight("ALLUP_BUTTON"); break;
		case "ALLUP_BUTTON":	SelectButtonRight("ALLDOWN_BUTTON"); break;
		}
	}
}

void ThatOneAndEquiped(string itmName1, string itmName2)
{
	if( !GetRemovable(g_refItems) )
	{
		SetSelectable("ONEDOWN_BUTTON",false);
		SetSelectable("ALLDOWN_BUTTON",false);
		SetSelectable("SWAP_BUTTON",false);
		SetSelectable("ONEUP_BUTTON",false);
		SetSelectable("ALLUP_BUTTON",false);
		return;
	}

	if( IsEquipCharacterByItem(GetMainCharacter(),itmName1) )
	{
		if( GetCharacterItem(GetMainCharacter(),itmName1)<=1 )
		{
			SetSelectable("ONEDOWN_BUTTON",false);
		}
		SetSelectable("ALLDOWN_BUTTON",false);
		SetSelectable("SWAP_BUTTON",false);
	}

	if( IsEquipCharacterByItem(g_refItems,itmName2) )
	{
		if( GetCharacterItem(g_refItems,itmName2)<=1 )
		{
			SetSelectable("ONEUP_BUTTON",false);
		}
		SetSelectable("ALLUP_BUTTON",false);
		SetSelectable("SWAP_BUTTON",false);
	}
}

void SetScrollsUsing()
{
	if( CheckAttribute(&GameInterface,"two_itemslist.pic1") ) {
		SendMessage(&GameInterface,"lsll", MSG_INTERFACE_MSG_TO_NODE,"TWO_ITEMSLIST",0, true);
		SetSelectable("TWO_ITEMSLIST",true);
		SetSelectable("TWO_LEFTSCROLLBUTTON",true);
		SetSelectable("TWO_RIGHTSCROLLBUTTON",true);
	} else {
		SendMessage(&GameInterface,"lsll", MSG_INTERFACE_MSG_TO_NODE,"TWO_ITEMSLIST",0, false);
		SetSelectable("TWO_ITEMSLIST",false);
		SetSelectable("TWO_LEFTSCROLLBUTTON",false);
		SetSelectable("TWO_RIGHTSCROLLBUTTON",false);
		if( GetCurrentNode()=="TWO_ITEMSLIST" ) {
			SetCurrentNode("ONE_ITEMSLIST");
		}
	}

	if( CheckAttribute(&GameInterface,"one_itemslist.pic1") ) {
		SendMessage(&GameInterface,"lsll", MSG_INTERFACE_MSG_TO_NODE,"ONE_ITEMSLIST",0, true);
		SetSelectable("ONE_ITEMSLIST",true);
		SetSelectable("ONE_LEFTSCROLLBUTTON",true);
		SetSelectable("ONE_RIGHTSCROLLBUTTON",true);
	} else {
		SendMessage(&GameInterface,"lsll", MSG_INTERFACE_MSG_TO_NODE,"ONE_ITEMSLIST",0, false);
		SetSelectable("ONE_ITEMSLIST",false);
		SetSelectable("ONE_LEFTSCROLLBUTTON",false);
		SetSelectable("ONE_RIGHTSCROLLBUTTON",false);
		if( GetCurrentNode()=="ONE_ITEMSLIST" ) {
			if( GetSelectable("TWO_ITEMSLIST") ) {SetCurrentNode("TWO_ITEMSLIST");}
		}
	}
}

void GoToTopScroll()
{
	if( GetSelectable("ONE_ITEMSLIST") ) SetCurrentNode("ONE_ITEMSLIST");
}

void GoToBottomScroll()
{
	if( GetSelectable("TWO_ITEMSLIST") ) SetCurrentNode("TWO_ITEMSLIST");
}

// KK -->
void ShowDescription(string sNode)
{
	string itmname, itmdescr, picStr, texStr;
	int iScroll = sti(GetSymbol(sNode, 5));
	int iRect = sti(strcut(sNode, 7, strlen(sNode) - 1));
	GetDescribeData(iScroll, iRect, &itmname, &itmdescr, &picStr, &texStr);
	if (itmname == "" && itmdescr == "") return;
	SetToolTipRectangle("");
	SetToolTipHeader("", itmname);
	SetToolTipText("", itmdescr);
	SetToolTipPicture("", texStr, picStr);
	ShowToolTip();
}

void SetImageGroups()
{
	aref arImgGrp, arItem;
	makearef(arImgGrp, GameInterface.one_itemslist.ImagesGroup);
	int iNum = GetAttributesNum(arImgGrp);
	for (int i = 0; i < iNum; i++)
	{
		arItem = GetAttributeN(arImgGrp, i);
		AddToolTipPictureImageGroup(GetAttributeValue(arItem));
	}
	makearef(arImgGrp, GameInterface.two_itemslist.ImagesGroup);
	iNum = GetAttributesNum(arImgGrp);
	for (i = 0; i < iNum; i++)
	{
		arItem = GetAttributeN(arImgGrp, i);
		AddToolTipPictureImageGroup(GetAttributeValue(arItem));
	}
}
// <-- KK
